#!/usr/bin/env python3
# -*- coding: utf-8 -*-

#	CaptureFlash-3.2	28 Juin 2017

#  Copyright 2017  <pi@CDBI-PI3>

#Utilise Boitier PI3-Version 2

#Sflash = N° Sortie de commande du flash auto alimenté
#numB = N° du Bouton
#numB=-3 pour Fermeture
#numB=-2 pour afficher le menu
#numb=-1 pour ne pas re-afficher le menu

import os
import sys
import pickle
import pifacedigitalio as pfio
import picamera
import RPi.GPIO as GPIO
from sense_hat import SenseHat
from time import sleep
from datetime import datetime
from subprocess import call

#======================================================================
def switch_pressed (event):
	sleep(0.3)
	sense.clear()
	Buz.start(10)
	sleep(0.1)
#======================================================================
def switch_unpressed (event):
	global numB,local,FlagRun,FlagStream
	sleep(0.3)
	numB=event.pin_num
	Buz.stop()
	sense.clear()
	sleep(0.1)
	if (FlagRun == False):
		if numB == 0:
			numB=-3
		elif numB ==1:
			local="L"
		elif numB == 2:
			local="D"
		elif numB == 5:
			#Test Flash ou relais 1 pour IR
			Flash()
		sense.show_letter("?")

	else:
		if (numB == 0):
			numB=-3
			print ("Arret Demandé")
		elif (numB == 1):
			Capt_Video()
		elif (numB == 2):
			Capt_Photo()
		elif (numB == 3):
			Shot()
		elif (numB == 4):
			FlagStream= not FlagStream
			Stream(FlagStream)
		elif (numB == 5):
			Flash()

		sense.show_letter(local)

#===================================================================
def Flash():
	#allume le flash sur la sortie Sflash ou l'IR sur le relais 1
	if pfd.input_pins[6].value  == 0:
		pfd.leds[Sflash].toggle()
		sleep(0.2)
	else:
		pfd.leds[0].toggle()
		#il faut attendre pour le Projecteur IR
		sleep(2)
#===================================================================
def Existe(f):
	try:
		nF=open(f,'r')
		nF.close()
		return 1
	except:
		return 0

#======================================================================
def Config(f):
	global Dossier
	global fichierP,dureeP,lapseP,heureP
	global fichierV,dureeV,heureV,enrV
	print ("ENTREE CONFIGURATION Mode LOCAL")
	try:
		r=input("Dossier Principal: ")
		if r != "":
			Dossier=r
		else:
			raise KeyboardInterrupt
		r=input("Nom des Fichiers Photos; ")
		if r != "":
			fichierP=r
		r=input("Durée totale de Prises en Minutes: ")
		if r !="":
			dureeP=float(r)
		r=input("Intervalle entre Prise en Secondes: ")
		if r !="":
			lapseP=int(r)
		r=input("Heure Début Phpto (HH:MM): ")
		if r !="":
			heureP=r
		print ("--------------------------------------")
		r=input("Nom des Fichiers Vidéos: ")
		if r !="":
			fichierV=r
		r=input("Durée Vidéo en Minutes: ")
		if r !="":
			dureeV=float(r)
		r=input("Heure Début Vidéo (HH:MM): ")
		if r !="":
			heureV=r
		r=input("Enregistrement de la Vidéo O/N: ")
		if r !="":
			enrV=str.upper(r)
		ENR_Config(f)
		return 1

	except(KeyboardInterrupt):
		return 0

#======================================================================
def ENR_Config(f):
	nF=open(f,'wb')
	#Mise des données en Dictionaire
	ConfDATA= {
		'Dossier' : Dossier,
		'fichierP' : fichierP,
		'dureeP' : dureeP,
		'lapseP' : lapseP,
		'heureP' : heureP,
		'fichierV' : fichierV,
		'dureeV' : dureeV,
		'heureV' : heureV,
		'enrV' : enrV
		}
	pickle.dump(ConfDATA,nF)
	nF.close()

#======================================================================
def AFFI_Config():
	print ("CONFIGURATION en Mode LOCAL")
	print ("--------------------------------------------------------")
	print ("Dossier Principal		:" + Dossier)
	print ("Nom Fichiers Photo		:" + fichierP)
	print ("Durée totale de Prises (Mn)	:" + str(dureeP))
	print ("Intervalle entre Prise (S)	:" + str(lapseP))
	print ("Heure début Photo (HH:MM)	:" + heureP)
	print ("Nom Fichiers Vidéo		:" + fichierV)
	print ("Durée Vidéo (Mn)		:" + str(dureeV))
	print ("Heure début Vidéo (HH:MM)	:" + heureV)
	print ("Enregistrement Vidéo (O/N)	:" + enrV)
	print ("--------------------------------------------------------")
	r=str.upper(input("Modifier O/N ?"))
	if r == "O":
		return 1
	else:
		return 0

#======================================================================
def LIRE_Config(f):
	global Dossier
	global fichierP,dureeP,lapseP,heureP
	global fichierV,dureeV,heureV,enrV
	if Existe(f):
		try:
			nF=open(f,'rb')
			ConfDATA=pickle.load(nF)
			nF.close()
			Dossier=ConfDATA['Dossier']
			fichierP=ConfDATA['fichierP']
			dureeP=ConfDATA['dureeP']
			lapseP=ConfDATA['lapseP']
			heureP=ConfDATA['heureP']
			fichierV=ConfDATA['fichierV']
			dureeV=ConfDATA['dureeV']
			heureV=ConfDATA['heureV']
			enrV=ConfDATA['enrV']
			return 1
		except:
			nF.close
			return 0
	else:
		return 0

#======================================================================
def Shot():
	chemin=Dossier + "Photos/"
	Flash()
	print ("Shot dans 5 S ")
	cam.resolution=(1024,768)
	cam.start_preview()
	sleep(5)
	cam.stop_preview()
	timestamp=datetime.now().strftime('_%d-%m-%Y_%H-%M-%S')
	Fn=chemin + 'Pic' + str(timestamp) + '.jpg'
	cam.resolution=(2048,1536)
	cam.capture(Fn,resize=(2048,1536))
	Flash()
	print ("Shot OK")
	numB =-2

#======================================================================
def Stream(run):
	Flash()
	cam.resolution=(1024,768)
	if (run == True):
		cam.start_preview()
	else:
		cam.stop_preview()
	numB=-2

#======================================================================
def Fermer():
	FlagRun=False
	sleep(0.1)
	for s in range(8):
		pfd.leds[s].turn_off()
	listener.deactivate()
	pfio.deinit()
	sense.clear()
	cam.close()
	print ("\n << Fermeture >>")
	sys.exit(0)

#======================================================================
def Capt_Photo():
	chemin=Dossier + "Photos/"

	global numB
	print ("")
	print (" ______________ ")
	print ("|CAPTURE PHOTOS|")
	print ("|______________|")
	print ("Destination: " + chemin)

	if local == "D":
		fP=input("Nom des Fichiers > ")
		if (fP == ""):
			raise (KeyboardInterrupt)
		dP=float(input ("Duree Totale (Mn) > "))
		lP=int(input("Intervalle (S) > "))
		hP=input("Heure Début (HH:MM) > ")
	else:
		fP=fichierP
		dP=dureeP
		lP=lapseP
		hP=heureP

	if (dP > 0) and (lP > 0):
		nb=int(dP*60/lP)
		print ("Cela fera " + str(nb) + " Photos")
		#PréVisu si en Distant
		if (local == "D"):
			cam.resolution=(1024,768)
			print ("PreVisu de 5 S");
			Flash()
			cam.start_preview()
			sleep(5)
			cam.stop_preview()
			Flash()

		#Attend heure de début si existe
		T=""
		if (hP != "0"):
			print ("Attente jusqu'à: " + hP)
			sense.show_letter("T")
			while hP != T:
				T=datetime.now().strftime('%H:%M')

		sense.show_message(str(dP) + "/" + str(lP),text_colour=[0,0,200])
		try:
			cpt=1
			cam.resolution=(2048,1536)
			#cam.start_preview()
			#sleep(2)
			#cam.stop_preview()
			while (cpt <= nb):
				#on déclenche le flash 1 seconde avant
				sleep(lP-1)
				Flash()
				Fn=chemin +  fP + '_A' + str(cpt) + datetime.now().strftime('-%d%m-%H%M')+'.jpg'
				sleep(1)
				cam.capture(Fn,resize=(2048,1536))
				Flash()
				print (Fn)
				sense.show_message(str(cpt) +"/" + str(nb),text_colour=[0,0,200])
				cpt +=1

			print ("PHOTO AUTO...Termine")
			numB=-2

		except (KeyboardInterrupt):
			print ("PHOTO...ARRET")
			Flash()
			numB=-2

	sense.show_letter(local,text_colour=[200,100,100])
	numB=-2

#======================================================================
def Capt_Video():
	cam.resolution=(1024,768)
	#cam.resolution=(1920,1080)
	chemin= Dossier + "Videos/"
	global numB
	print ("")
	print (" _____________ ")
	print ("|CAPTURE VIDEO|")
	print ("|_____________|")
	
	if local == "D":
		eV=str.upper(input("Enregistrement (O/N) > "))
		if (eV == ""):
			raise (KeyboardInterrupt)
		elif (eV == "O"):
			fV=input("Nom du Fichier > ")
			if (fV == ""):
				raise (KeyboardInterrupt)
		dV=float(input("Durée (Mn) > "))
		if (dV == 0):
			raise (KeyboardInterrupt)
		hV=input("Heure Début (HH:MM) > ")

	else:
		fV=fichierV
		eV=enrV
		dV=dureeV
		hV=heureV

	if (dV == 0):
		raise (KeyboardInterrupt)
	dVS=int(dV*60)

	#Attend heure de début si existe
	T=""
	if (hV != "0"):
		print ("Attente jusqu'à: " + hV)
		sense.show_letter("T")
		while hV != T:
			T=datetime.now().strftime('%H:%M')

	Flash()
	sleep(1)

	try:
		if (eV == "O"):
			Ftemp=chemin + fV  + '.h264'
			Fn=chemin + fV + datetime.now().strftime('-%d%m-%H%M') + ".mp4"

			if (local == "D"):
				print ("Destination:" + Fn)
				print ("Pre-Visu de 10 secondes")
				cam.start_preview()
				sleep(10)
				cam.stop_preview()
			else:
				sense.show_message ("ENR " + str(dV) +" Mn)")

			print ("ENREGISTREMENT EN COURS (" + str(dV) + " Mn)")
			cam.start_recording(Ftemp)
			cam.wait_recording(dVS)
			cam.stop_recording()
			Flash()
			print ("VIDEO...Terminee")
			#Conversion en MP4 et suppression du H264
			print ("Conversion MP4")
			cmd="MP4Box -add " + Ftemp + " " + Fn
			call (cmd,shell=True)
			os.remove(Ftemp)
			numB=-2

		elif (eV == "N") and (local == "D"):
			print ("Visu de:" + str(dV))
			sense.show_message("Visu de:" + str(dV))
			cam.start_preview()
			sleep(dVS)
			cam.stop_preview()
			Flash()
			print ("VIDEO...Terminee")
			numB=-2

		elif (eV == "N") and (local == "L"):
			print ("Enregistrement non Validé")
			Flash()
			numB=-2

	except (KeyboardInterrupt):
		Flash()
		cam.stop_preview()
		print ("VIDEO...ARRET")
		numB=-2

	sense.show_letter(local,text_colour=[200,100,100])
	numB=-2

#=========================== MAIN =====================================
pfio.init()
pfd = pfio.PiFaceDigital()
#Active Piface2 Listener pour les Boutons
listener = pfio.InputEventListener(chip=pfd)
for i in range(6):
	listener.register(i, pfio.IODIR_ON, switch_pressed)
	listener.register(i, pfio.IODIR_OFF, switch_unpressed)
listener.activate()

sense = SenseHat()
sense.low_light=True
sense.set_rotation(0)
cam = picamera.PiCamera()

#On met le GPIO18 en sortie et PWM pour le Buzzer
#disable warnings car déjà utilisé par le ShutDown
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(18,GPIO.OUT)
Buz=GPIO.PWM(18,600)

local="-"
global Sflash
Dossier=""
fichierP=""
dureeP=0
lapseP=0
heureP=""
fichierV=""
dureeV=0
enrV=""
Sflash=2	#Sortie 2 de la piface pour le flash
fichierConf="/home/pi/Projets-Python/CaptP.cfg"
FlagRun=False
FlagStream=False
numB=-2  #Affiche les Menus

try:
	if pfd.input_pins[6].value  == 0:
		#Camera Normale
		cam.brightness=53     #0 à +100
		cam.contrast=5        #-50 à +50
	else:
		#Camera IR
		cam.brightness=60    #0 à +100
		cam.contrast=10      #-50 à +50

	if pfd.input_pins[7].value  == 1:
		local="L"
	else:
		local="D"

	numB=-2
	FlagRun=True
	if not LIRE_Config(fichierConf):
		print (fichierConf)
		print ("Pas de Configuration enregistrée")
		if not Config(fichierConf):
			numB=-3

	while(FlagRun):
		if (numB == -2) and (local == "L"):
			print ("		 _____________________________")
			print ("		|   CAPTURE-PHOTO-VIDEO 3.2   |")
			print ("		|       COMMANDE-LOCALE       |")
			if pfd.input_pins[6].value  == 0:
				print ("		|       Camera Normale        |")
			else:
				print ("		|       Camera IR             |")
			print ("		| Bouton 0  Fermer            |")
			print ("		| Bouton 1  Video             |")
			print ("		| Bouton 2  Photo             |")
			print ("		| Bouton 3  Shot              |")
			print ("		| Bouton 4  Stream Vidéo      |")
			print ("		| Bouton 5  Test Flash        |")
			print ("		|_____________________________|")
			print ("		Attente Boutons de la PiFace")
			sense.show_letter("L",text_colour=[200,100,100])
			numB=-1  #pour ne pas re-afficher

		elif (numB == -2) and (local == "D"):
			print ("		 ___________________________ ")
			print ("		|   CAPTURE-PHOTO-VIDEO 3.2 |")
			print ("		|     COMMANDE-DISTANTE     |")
			if pfd.input_pins[6].value  == 0:
				print ("		|     Camera Normale        |")
			else:
				print ("		|     Camera IR             |")
			print ("		| 0=Fermer (CTRL-C)         |")
			print ("		| 1=Video                   |")
			print ("		| 2=Photo                   |")
			print ("		| 3=Shot                    |")
			print ("		| 4=Stream Vidéo            |")
			print ("		| 5=Test Flash              |")
			print ("		| 6=Configuration Mode Local|")
			print ("		|___________________________|")
			sense.show_letter("D",text_colour=[200,100,100])
			numB=-1  #Pour ne pas re-afficher
			#On désactive les boutons en Distant
			listener.deactivate()
			choix=input("		Votre Choix > ")
			if (choix == "0"):
				Fermer()
			elif (choix == "1"):
				Capt_Video()
			elif (choix == "2"):
				Capt_Photo()
			elif (choix == "3"):
				Shot()
			elif (choix == "4"):
				FlagStream=not FlagStream
				Stream(FlagStream)
			elif (choix == "5"):
				Flash()
			elif (choix == "6"):
				if AFFI_Config() == True:
					Config(fichierConf)
				numB=-2

		elif (numB == -1) and (local == "D"):
			#On désactive les boutons
			listener.deactivate()
			choix=input("		Votre Choix > ")
			if (choix == "0"):
				Fermer()
			elif (choix == "1"):
				Capt_Video()
			elif (choix == "2"):
				Capt_Photo()
			elif (choix == "3"):
				Shot()
			elif (choix == "4"):
				FlagStream=not FlagStream
				Stream(FlagStream)
			elif (choix == "5"):
				Flash()
			elif (choix == "6"):
				if AFFI_Config() == True:
					Config(fichierConf)
				numB=-2

		elif (numB == -3):
			Fermer()

	Fermer()

except (KeyboardInterrupt):
	Fermer()
