#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  Lanceur-1.1		28 JUIN 2017
#  
#  Copyright 2017  <pi@CDBI-PI3>
#  
#  Appellé au boot du raspi
#  Boitier PI3-Version 3
#  Utilise les boutons de la Piface pour choisir un script
#  

import sys
from subprocess import call
from time import sleep
import pifacedigitalio as pfio
from sense_hat import SenseHat

#====================================================================
def SW_pressed(event):
	global numB
	sense.clear()
	numB=str(event.pin_num)

#====================================================================
def SW_unpressed(event):
	global Cmd
	if event.pin_num == 0:
		Cmd=""
	elif event.pin_num == 1:
		Cmd="/home/pi/Projets-Python/CaptureFlash-32.py"
	elif event.pin_num == 2:
		Cmd="python /home/pi/Projets-Python/SenseHat-20.py"
	elif event.pin_num == 3:
		Cmd="python /home/pi/Projets-Python/SenseHat-21.py"
	#elif event.pin_num == 4:
	
	#elif event.pin_num == 5:
		
	else:
		Cmd="?"

#====================================================================
def Fermer(Cmd):
	sense.clear()
	if (Cmd == ""):
		print ("<< Fermeture >>")
		listener.deactivate()
		pfio.deinit()
		sys.exit(0)

	else:
		print (Cmd)
		listener.deactivate()
		pfio.deinit()
		call(Cmd,shell=True)
		sys.exit(0)

#=============================MAIN===================================
pfio.init()
pfd=pfio.PiFaceDigital()
sense = SenseHat()

if pfd.input_pins[7].value  == 0:
	#Le Boitier est en mode Distant----on sort
	pfio.deinit()
	sense.show_letter("A")
	print ("Fermeture---Boitier en Mode Distant")
	sleep(2)
	sense.clear()
	sys.exit(0)

listener=pfio.InputEventListener(chip=pfd)
for i in range(6):
	listener.register(i,pfio.IODIR_ON,SW_pressed)
	listener.register(i,pfio.IODIR_OFF,SW_unpressed)
listener.activate()

sense.clear()
sense.low_light=True
sense.set_rotation(0)

Cmd="?"

try:
	print (" _______________________________ ")
	print ("|        CDBI  Ver 1.1          |")
	print ("|      LANCEUR de Scripts       |")
	print ("| Bouton 0  Rien (CTRL-C)       |")
	print ("| Bouton 1  Capture Photo/Video |")
	print ("| Bouton 2  SenseHat-20         |")
	print ("| Bouton 3  SenseHat-21         |")
	print ("| Bouton 4  ........            |")
	print ("| Bouton 5  ........            |")
	print ("|_______________________________|")

	while Cmd == "?":
		sense.show_letter("?",text_colour=[200,200,0],back_colour=[0,50,0])
		sleep(1)

	Fermer(Cmd)

except (KeyboardInterrupt):
	Fermer("")
